'--------------------------------------------
'Author      : Dr. Fritz Faulhaber GmbH & Co. KG
'Date        : 07.10.2015
'--------------------------------------------
'Description : Positioning with waiting time
'
'Sequence program for controllers of the family MC V3.x 
'--------------------------------------------
DEF_TIM_VAR t

GOSUB Initialize
GOSUB SetTimer_500

z = 1                                                                    'Step counter
:MainLoop
IF z = 1 THEN GOSUB CheckTimer
IF z = 2 THEN GOSUB Move_Rel_1
IF z = 3 THEN GOSUB CheckTargetReached
IF z = 4 THEN GOSUB SetTimer_2000
IF z = 5 THEN GOSUB CheckTimer
IF z = 6 THEN GOSUB Move_Rel_2
IF z = 7 THEN GOSUB CheckTargetReached
IF z = 8 THEN GOSUB SetTimer_2000
IF z = 9 THEN
   z = 1
ENDIF
GOTO MainLoop

'Set Profile Position Mode and activate power stage
:Initialize
SETOBJ $6060.00 = 1                                                      'Modes of operation
a = GETOBJ $6041.00                                                      'Request Statusword
IF (a & $004) <> $004 THEN                                               '"Operation Enabled" not set
   SETOBJ $6040.00 = $06                                                 'Shutdown
   SETOBJ $6040.00 = $07                                                 'Switch On
ENDIF
z = z + 1
RETURN

'Set 500ms waiting time
:SetTimer_500
START_TIM 500
z = z + 1
RETURN

'Set 2 Sec. waiting time
:SetTimer_2000
START_TIM 2000
z = z + 1
RETURN

'Wait until time expired
:CheckTimer
IF t = 1 THEN
   z = z + 1
ENDIF
RETURN

'Start positioning relative 10000
:Move_Rel_1
SETOBJ $607A.00 = 10000                                                  'Target Position
SETOBJ $6040.00 = $0F                                                    'Enable Operation
SETOBJ $6040.00 = $7F                                                    'Move relative
z = z + 1
RETURN

'Start positioning relative -10000
:Move_Rel_2
SETOBJ $607A.00 = -10000                                                 'Target Position
SETOBJ $6040.00 = $0F                                                    'Enable Operation
SETOBJ $6040.00 = $7F                                                    'Move relative
z = z + 1
RETURN

'Wait until target reached
:CheckTargetReached
a = GETOBJ $6041.00                                                      'Request Statusword
IF (a & $400) = $400 THEN                                                '"Target Reached" set
   z = z + 1
ENDIF
RETURN

