'--------------------------------------------
'Description :   Short example of standard program structures
'--------------------------------------------
'This example introduces a common programming technique
'to new users and allows to break up the problem by simply
'dividing it into multiple parts.
'--------------------------------------------

:Initialize
LET z = 10                                                               'variable: z is the usual stepping variable
LET a = 2                                                                'variable: used for some trivial 'calculation'


'the main stepping loop
:MainLoop
   IF z = 10 THEN GOSUB calculate_condition
   IF z = 20 THEN GOSUB new_setpoint
   IF z = 30 THEN GOSUB checkTargetReached
GOTO MainLoop

'start our condition 'calculation'
:calculate_condition
   IF a = 2 THEN                                                         'is a equal to 2
      a = 4                                                              'set a to 4
   ELSEIF a > 3 THEN                                                     'is a bigger than 3
      a = 1                                                              'set a to 1
   ELSEIF ((a & 1) = 1) THEN                                             'check if bit one of a is set (oddity check)
      a = 2                                                              'set to 2 and start again
      z = 20                                                             'calculation is done; we can continue with the setpoint
   ENDIF
RETURN

'set a new position and enable the motor
:new_setpoint
   SETOBJ $607A.00=-1000                                                 'set the demand position
   SETOBJ $6040.00=$007F                                                 'start relative position
   SETOBJ $6040.00=$000F                                                 'enable operation
   z=30                                                                  'continue with the next step
RETURN

'wait until target is reached
:checkTargetReached
   a = GETOBJ $6041.00                                                   'get the statusword
   IF ( ( a & $400 ) = 0 ) THEN                                          'checking if bit 10 of the statusword (Target Reached) is 0
      z=30                                                               'target is not reached, check again
   ELSE
      z= 10                                                              'start the  'calculation' again
   ENDIF
RETURN
